Index: mg2ec_const.h
===================================================================
--- mg2ec_const.h       (revision 2504)
+++ mg2ec_const.h       (working copy)
@@ -74,6 +74,12 @@
 /* Backup coefficients every this number of samples */
 #define BACKUP 256

+/* If defined then agressive echo cancellation will only be used for
+ * this amount of time then we will go back to normal cancelation.
+ * This is helpful if you have bad echo while training
+ */
+/* #define AGGRESSIVE_TIMELIMIT 150000 */ /* 8 = 1ms */
+
 /***************************************************************/
 /* The following knobs are not implemented in the current code */

Index: mg2ec.h
===================================================================
--- mg2ec.h     (revision 2504)
+++ mg2ec.h     (working copy)
@@ -556,6 +556,9 @@

 #ifndef NO_ECHO_SUPPRESSOR
 #ifdef AGGRESSIVE_SUPPRESSOR
+#ifdef AGGRESSIVE_TIMELIMIT
+       if (ec->i_d < AGGRESSIVE_TIMELIMIT ) {
+#endif
        if ((ec->HCNTR_d < AGGRESSIVE_HCNTR) && (ec->Ly_i > (ec->Lu_i << 1))) {
                for (k=0; k < RESIDUAL_SUPRESSION_PASSES; k++) {
                        u = u * (ec->Lu_i >> DEFAULT_SIGMA_LU_I) / ((ec->Ly_i >> (DEFAULT_SIGMA_LY_I)) + 1);
@@ -567,7 +570,12 @@
                ++ec->cntr_residualcorrected_frames;
 #endif
        }
-#else
+#ifdef AGGRESSIVE_TIMELIMIT
+       }
+       else {
+#endif
+#endif
+#if (defined AGGRESSIVE_SUPPRESSOR  && defined AGGRESSIVE_TIMELIMIT) || !defined AGGRESSIVE_SUPPRESSOR
        if (ec->HCNTR_d == 0) {
                if ((ec->Ly_i/(ec->Lu_i + 1)) > DEFAULT_SUPPR_I) {
                        for (k=0; k < RESIDUAL_SUPRESSION_PASSES; k++) {
@@ -586,6 +594,9 @@
                }
 #endif
        }
+#ifdef AGGRESSIVE_TIMELIMIT
+       }
+#endif
 #endif
 #endif
